/* ============================ */
/*        Manuel Gallegos       */
/*             args.c           */
/*           Fall 1995          */
/* ============================ */

#include "checkin.h"

void inderr (char *cmd);

INTER check_args ( int argc, char *argv[] )
{
  char *dmsg;
  INTER setrec = {NULL,NULL,NULL,0,NULL,NULL,0,0,0,0,0,0,0,0,NULL,0,0};

  dmsg = (char *) malloc (sizeof(char)*80);
	 
  debug_msg ("checking # of args ...");
  if ( (argc < 1) || ( (argc > 1) && (argv[1][0] != '-') ) )
    {
      inderr (argv[0]);
    }
  if (argc == 1)
    {
      return setrec;
    }
  if (!strcmp(argv[1],"-h"))
    {
      inderr (argv[0]);
    }
  if (!strcmp(argv[1],"--help")) 
    {
      helpscreen (argv[0]);
    }
  setrec.arg = 1;
  debug_msg("checking arguments");
  while (setrec.arg < argc)
    {
      sprintf(dmsg,"  arg #%2d",(setrec.arg+1));
      debug_msg(dmsg);
      setrec = checkopts (argc,argv,setrec);
    }
  if ( (setrec.gtime || setrec.gdiff) && (setrec.cmdline || setrec.infile || setrec.desc || setrec.timeout || setrec.diffopt || setrec.outfiles) )
    inderr (argv[0]);

  return setrec;
}

INTER checkopts ( int argc, char *argv[], INTER srec )
{
  char *dmsg;

  dmsg = (char *) malloc (sizeof(char)*90);

  if (argv[srec.arg][0] != '-')
    {
      inderr(argv[0]);
    }
  switch (argv[srec.arg][1]) 
    {
    case 'd':
      srec.desc = 1;
      srec = getstring (argc,argv,srec,2);
      strcpy(srec.dsc,srec.temp);
      sprintf(dmsg,"  desc=%s",srec.dsc);
      break;
    case 'e':
      srec.cmdline = 1;
      srec = getstring (argc,argv,srec,2);
      strcpy(srec.cmd,srec.temp);
      sprintf(dmsg,"  cmd=%s",srec.cmd);
      break;
    case 'f':
      srec.infile = 1;
      srec = getstring (argc,argv,srec,2);
      strcpy(srec.ifile,srec.temp);
      sprintf(dmsg,"  infile=%s",srec.ifile);
      break;
    case 'o':
      srec.outfiles = 1;
      srec = getstring (argc,argv,srec,2);
      strcpy(srec.ofile,srec.temp);
      sprintf(dmsg,"  outfiles=%s",srec.ofile);
      break;
    case 't':
      srec.timeout = 1;
      srec = getstring (argc,argv,srec,2);
      srec.tout = atoi(srec.temp);
      sprintf(dmsg,"  timeout=%d",srec.tout);
      break;
    case 'D':
      srec.diffopt = 1;
      srec = getstring (argc,argv,srec,2);
      strcpy(srec.dopt,srec.temp);
      sprintf(dmsg,"  diffopt=%s",srec.dopt);
      break;
    case 'g':
      switch (argv[srec.arg][2])
	{
	case 't':
	  srec.gtime = 1;
	  srec = getstring (argc,argv,srec,3);
	  gtime = atoi(srec.temp);
	  if (gtime != 0)
	    printf("Global timeout now set to %6d minutes.\n",gtime);
	  else
	    printf("Global timeout set to infinite time.\n");
	  sprintf(dmsg,"  global time=%d",gtime);
	  break;
	case 'd':
	  srec.gdiff = 1;
	  srec = getstring (argc,argv,srec,3);
	  strcpy(gdiff,srec.temp);
	  if (strlen(gdiff) != 0)
	    printf("Global diff options now set to \"%s\".\n",gdiff);
	  else
	    printf("Global diff options unset.\n");
	  sprintf(dmsg,"  global diff=%s",gdiff);
	  break;
	default:
	  inderr(argv[0]);
	  break;
	}
      break;
    default:
      inderr(argv[0]);
      break;
    }
  debug_msg(dmsg);

  return srec;
}

INTER getstring ( int argc, char *argv[], INTER rec, int size )
{
  int k;

  if (strlen(argv[rec.arg]) == size)
    {
      if ( (rec.arg+1 == argc) || ( (argv[rec.arg+1][0] == '-') && ( (strcmp(argv[rec.arg],"-gd")) && (strcmp(argv[rec.arg],"-D")) ) ) )
	{
	  rec.temp[0] = '\0';
	}
      else
	{
	  rec.arg++;
	  if (rec.arg < argc)
	    strcpy(rec.temp,argv[rec.arg]);
	}
    }
  else
    {
      for (k=size;argv[rec.arg][k] != '\0';k++)
	rec.temp[k-size] = argv[rec.arg][k];
    }
  rec.arg++;
 
  return rec;
}

void inderr (char *cmd)
{
  fprintf(stderr,"Usage --- (styles cannot be used together)\n");
/*  fprintf(stderr,"completely interactive style:\n");
  fprintf(stderr,"%s\n\n",cmd);  */
  fprintf(stderr,"check-in a test interactive style: (set any or all of the following)\n");
  fprintf(stderr,"%s [-d<desc>] [-e<cmd>] [-f<infile>] [-t<time>] [-o<outfiles>] [-D<diff>]\n\n",cmd);
  fprintf(stderr,"global defaults style: (set both or only one)\n");
  fprintf(stderr,"%s [-gt<global timelimit>] [-gd<global diff options>]\n\n",cmd);
  fprintf(stderr,"help screen style: (many screens)\n");
  fprintf(stderr,"%s [--help]\n\n",cmd);
  fprintf(stderr,"this help screen: \n");
  fprintf(stderr,"%s [-h]\n\n",cmd);
  exit (USAGE);
}

void helpscreen (char *cmd)
{
printf("Usage:\n");
printf("%s [-d<desc>] [-e<cmd>] [-f<infile>] [-t<time>] [-o<outfiles>] [-D<diff>]\n",cmd);
printf("     -d <description>      description of test (in quotation marks\n");
printf("                           if longer than 1 word) - optional\n");
printf("     -e <command to run>   executable to test (in quotation\n");
printf("                           marks if longer than 1 word)\n");
printf("     -f <input file>       input file to use as stdin for the\n");
printf("                           test -- default is interactive\n");
printf("     -t <time limit>       time limit to allow test to run\n");
printf("                           (specified in minutes) -- optional\n");
printf("     -o <output files>     list of output files (in quotation\n");
printf("                           marks, seperated by spaces) created\n");
printf("                           that need to be checked - optional\n");
printf("     -D <diff options>     options to use with 'diff' when \n");
printf("                           running regression tester and searching\n");
printf("                           for variations between the just ran\n");
printf("                           test the accepted test - optional\n");
printf("                           an empty string means no options\n");
printf("                           (must be in quotation marks) \n");
printf("\n   the above options can be entered in any order and combination\n");
printf("   but they may not be combined with options listed below.\n");
printf("   the above options do not need to be entered at the command\n");
printf("   command line ... non-specified fields will be prompted\n");
printf("   for during an interactive session of %s\n\n",cmd);

printf("%s [-gt<global timelimit>] [-gd<global diff options>]\n",cmd);
printf("       -gt <global default time limit>     max time for tests that\n");
printf("                               do not have a limit set\n");
printf("                               (specified in minutes) - optional\n");
printf("                               not specifying removes the limit\n");
printf("       -gd <global diff options>     diff options for tests that\n");
printf("                               do not have diff options set (must\n");
printf("                               be in quotation marks) - optional\n");
printf("                               an empty string removes the options\n");

printf("\n%s [-h]\n",cmd);
printf("       show the usage help screen\n\n");

printf("\n%s [--help]\n",cmd);
printf("       show this help screen\n\n");


  exit (0);
}






