/*-------------------------------
  interactive stuff for checkin
  Sean McCullough
  bankshot@prism
  -----------------------------*/

#include "checkin.h"
#define mark printf("%d\n",__LINE__)

void interactive(CASES *tests, INTER rec)
{
char *s,*t;
int i,n;
FILE *dummyfp;
OUTF *of;

s= (char *)malloc(sizeof(char)*256);
t= (char *)malloc(sizeof(char)*256);

printf("This is test %d\n",getno(tests));
if (rec.cmdline)
  {
    setcmd(tests,rec.cmd);
  }
else
  {
    printf("Command line: ");
    s=gets(s);
    setcmd(tests,s);
  }

if(!fork())
  {
if (rec.infile)
  {
    if((dummyfp = freopen(rec.ifile,"r",stdin)) == NULL)
      perror("couldn't redirect stdin from input file");
  }
else
  {
    printf("Input file [keyboard interaction]: ");
    s=gets(s);
    if (strlen(s))
      {
	if((dummyfp = freopen(s,"r",stdin)) == NULL)
	  { 
	    perror("couldn't redirect stdin from input file");
	    exit(-1);
	  }
	rec.infile = 1;
      }
    else
      {
	printf("Checkin note:\n"
	       "Some cases will require you to manually place the EOF (^D)\n"
	       "[begin your input]\n");
      }
  }   
 
i = run_test(tests);
printf("(took %d min)\n",i);
exit(0);
}

wait();

if (rec.timeout)
  {
    settime(tests,rec.tout);
  }
else
  {
    printf("Current test's timeout in integer minutes [infinite]: ");
    s = gets(s);
    i = atoi(s);
    settime(tests,i);
  }



if (rec.outfiles)
  {
    setoutf(tests,rec.ofile);
  }
else
  {
    printf("Output files [none]: ");
    t=gets(t);
    setoutf(tests,t);
  }


/* copy output files to RTtests */
of = tests->curr->caseptr->output;
n = 0;

while (of)
  {
    sprintf(s,"cp %s %s/test-%d.file%d\n",of->fname,CDIR,getno(tests),n++);
    if(system(s)>>8)
      perror("calling system:");
    of = of->nextout;
  }

if (rec.desc)
  {
    setdesc(tests,rec.dsc);
  }
else
  {
    printf("One line description [none]: ");
    s=gets(s);
    setdesc(tests,s);
  }

if (rec.diffopt)
  {
    setdiff(tests,rec.dopt);
  }
else
  {
    printf("Current test's \"diff\" options [none]: ");
    s=gets(s);
    setdiff(tests,s);
  }

if (rec.gtime)
  {
    gtime = rec.gtime;
  }

if (rec.gdiff)
  { /* change to strcpy */
/*    gdiff = (char *)malloc(sizeof(char) * strlen(rec.dopt)); */
    strcpy(gdiff,rec.dopt);
  }

}



