/* Jonathan Raloff on Oct 1, 1995
 * create_output.c 
 * creates RTresults/test-#.output for the rt tester
 */
/****************************
** Updated for version 2   **
** by Asa Shows            **
****************************/
#include "rt.h"

extern CASES *tests;

/* filecopy   copy file ifp to file ofp */
int filecopy(char *fromthis, char *tothis)
{
  int c;
  FILE *ifp, *ofp;
  
  if ((ofp=fopen(tothis, "w"))==NULL)
  {
      fprintf(stderr, "Could not generate %s\n", tothis);
      return (ERR_OUT);
  }
  
  if((ifp=fopen(fromthis, "r"))!=NULL)
  {
      while ((c = getc(ifp)) != EOF)
         putc(c, ofp);
  }
  else
  {
      fclose (ofp);
      fprintf (stderr, "Could not open input %s\n", fromthis);
      return (ERR_IN);
  }

  fclose(ofp);
  fclose(ifp);

  return (0);
}

void create_output(int number)
{
  char outfile[80]=RDIR, infile[80];
  int  len, filenum, i, last;
  char nm[25],*ofstr, err, *tmp;
  FILE *out;

#ifdef DBUGMSG
  /*found*/debug_msg ("entering create_output");
#endif

  /* getting test # */
  sprintf (nm,"%d",number);

  /* Creating base filename */
  strcat(outfile, "/test-");
  strcat(outfile, nm);
  len=strlen (outfile);

   /* Generate stdout file 
  strcpy(&(outfile[len]), ".stdout");
  if (err=filecopy (TMP_OUT, outfile))
     seterror (tests, err);
  
  Generate stderr output file 
  strcpy(&(outfile[len]), ".stderr");
  if (err=filecopy (TMP_ERR, outfile))
     seterror (tests, err);
  
  Generate exitcode output file 
  strcpy(&(outfile[len]), ".exit  ");
  if ((out=fopen(outfile, "w"))!=NULL)
  {
      fprintf (out, "%d", exit_code);
      fclose (out);
  }      
  else
  {
      fprintf (stderr, "Unable to create exit code file %s\n", outfile);
      seterror (tests, ERR_OUT);
  } */

  /* Copy over all output files */
  if ((ofstr=getoutfiles (tests))!=NULL)
  {
      i=last=0;
      filenum=0;

      do
      {
	  /*Cycle through the string to next space or end of string*/
	  for (;i<strlen(ofstr);i++)
	     if (ofstr[i]==' ')
	        break;

	  /*Set up input file*/
	  strncpy (infile, &ofstr[last], (i-last)+1);
	  infile[(i-last)]=0;
	
	  /*Setup output file*/
	  sprintf (nm,".file%d", filenum);
	  strcpy(&(outfile[len]), nm);

	  /*Copy files*/
	  if (err=filecopy (infile, outfile))
	     seterror (tests, err);
	  
	  /*Setup last*/
	  last=i+1;
	  /*Increment over the space*/
	  i++;
	  /*Next file number*/
	  filenum++;

      }while (i<strlen(ofstr));
   }
}











