/*****************************************************************************
   rt v1
 * Jonathan Raloff on 10/1/95 
 * run_test.c
 * This program runs one test
 * and then compiles it's output
 ****************************************************************************

  rt v2, 20 November 1995, Randall Jones (rjones@cs.nmt.edu)

  Notes:
   
 ****************************************************************************/

#include "rt.h"

int intLength(int testInt);


void run_test(CASES *tests)
{
  int exit_code;
  int testNumber;
  char *tno, *dmsg;
  char *testin;

#ifdef DBUGMSG
  /*found*/debug_msg (" run_test: <begin>");
#endif

  testNumber = getno(tests);
  testin = (char *) malloc (sizeof(char) * (strlen(CDIR) +
					       strlen(TEST_LBL) +
					       intLength(testNumber) +
					       strlen(INPUT_EXT) + 1));
  sprintf(testin, "%s/%s%d%s", CDIR, TEST_LBL, testNumber, INPUT_EXT);

  if ((file_exist(testin)!=2)	/* && (file_exist(testin)!=1) */  )
  {
    fprintf(stderr, "error: can't find input file %s\n", testin);
    seterror (tests, ERR_IN);
  }
    
#ifdef DBUGMSG
  sprintf (dbgMsg, " run_test: input file -- error %d <%s>",
	   geterror(tests), testin);
  /*found*/debug_msg (dbgMsg);
#endif

  if (!geterror(tests))
  {
    /* run the current test */
    exit_code = exec_cmd (tests);
    create_output(getno(tests));
  }

#ifdef DBUGMSG
  sprintf (dbgMsg, " run_test: exec file -- error %d ", geterror(tests));
  /*found*/debug_msg (dbgMsg);

  /*found*/debug_msg (" run_test: <end>");
#endif
}
